/*********************************************************************
 *                
 * Copyright (C) 2002, 2003 University of New South Wales
 *                
 * File path:     glue/v4-alpha/schedule.h
 * Description:   
 *                
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *                
 * $Id: schedule.h,v 1.5.4.1 2003/09/24 19:12:20 skoglund Exp $
 *                
 ********************************************************************/

#include <config.h>

#include INC_ARCH(palcalls.h)

/**
 * @todo document me
 */
INLINE u64_t get_timer_tick_length()
{
    return TIMER_TICK_LENGTH;
}

/**
 * send the current processor to sleep
 */
INLINE void processor_sleep()
{
    /* We need to get timer interrupts, etc., so enable interrupts
     * here.  Note that we also need timer interrupts to be disabled when
     * we return so we don't get any nasty kernel-preemptions */
    word_t old_ipl = PAL::swpipl(PAL::IPL_all);
    for(int i = 0; i < 100; i++) {
	asm __volatile__ ("nop");
    }

    PAL::swpipl(old_ipl);
}
